## radare2 4.2.1%2Bdfsg

=== libr/anal/Makefile ===
include ../config.mk

EXTRA_TARGETS+=do
EXTRA_CLEAN=doclean
CFLAGS+=-I..

NAME=r_anal
DEPS=r_util r_reg r_syscall r_search r_cons r_flag r_hash r_crypto r_parse
CFLAGS+=-DR2_PLUGIN_INCORE -Iarch -I$(TOP)/shlr
CFLAGS+=-I$(LTOP)/asm/arch/include

LDFLAGS+=${BN_LIBS}

CURDIR=p/

include p/capstone.mk
LDFLAGS+=$(CS_LDFLAGS)
include $(STOP)/java/deps.mk
LDFLAGS+=$(LINK)

.PHONY: all plugins libs ${EXTRA_CLEAN}

all: plugins

plugins: ${LIBSO} ${LIBAR}
	@${MAKE} -C p all

include ${STATIC_ANAL_PLUGINS}

STATIC_OBJS=$(addprefix $(LTOP)/anal/p/,$(STATIC_OBJ))
OBJLIBS=meta.o reflines.o op.o fcn.o bb.o var.o block.o
OBJLIBS+=cond.o value.o cc.o class.o diff.o type.o
OBJLIBS+=hint.o anal.o data.o xrefs.o esil.o sign.o
OBJLIBS+=switch.o cycles.o esil_dfg.o
OBJLIBS+=esil_sources.o esil_interrupt.o esil_cfg.o
OBJLIBS+=esil_stats.o esil_trace.o flirt.o labels.o
OBJLIBS+=esil2reil.o pin.o session.o vtable.o rtti.o
OBJLIBS+=rtti_msvc.o rtti_itanium.o jmptbl.o function.o
ASMOBJS+=$(LTOP)/asm/arch/xtensa/gnu/xtensa-modules.o
ASMOBJS+=$(LTOP)/asm/arch/xtensa/gnu/xtensa-isa.o
ASMOBJS+=$(LTOP)/asm/arch/xtensa/gnu/elf32-xtensa.o

OBJS=${STATIC_OBJS} ${OBJLIBS} ${ASMOBJS}

test tests: tests-esil

tests-esil:
	cd ../../test ; \
		sh run_tests.sh t.esil

.PHONY: do doclean

do:
	${MAKE} -C d

doclean:
	${MAKE} -C d clean

include $(LTOP)/rules.mk

=== libr/bp/Makefile ===
include ../config.mk

NAME=r_bp
DEPS+=r_util

CFLAGS+=-DR2_PLUGIN_INCORE

.PHONY: pre
pre: libr_bp.${EXT_SO} libr_bp.${EXT_AR}
	${MAKE} -C p

include ${STATIC_BP_PLUGINS}
STATIC_OBJS=$(subst ..,p/..,$(subst bp_,p/bp_,$(STATIC_OBJ)))
OBJS=bp.o bp_watch.o bp_io.o bp_plugin.o bp_traptrace.o ${STATIC_OBJS}

include ../rules.mk

=== libr/debug/Makefile ===
include ../config.mk

NAME=r_debug
DEPS=r_reg r_anal r_bp r_io r_parse r_cons r_syscall r_hash r_flag r_util r_egg
DEPS+=r_socket
CFLAGS+=-DR2_PLUGIN_INCORE

ifeq ($(OSTYPE),bsd)
LDFLAGS=-lkvm
endif

foo:
	@${MAKE} libs
	@${MAKE} plugins

include ../config.mk
include ${STATIC_DEBUG_PLUGINS}

# Enable pure-MACH debugging by default.
# The ptrace one will be deprecated at some point
XNU_USE_PTRACE?=0
CFLAGS+=-DXNU_USE_PTRACE=$(XNU_USE_PTRACE)

STATIC_OBJS=$(subst ..,p/..,$(subst debug_,p/debug_,$(STATIC_OBJ)))

OBJS=signal.o map.o trace.o arg.o debug.o plugin.o snap.o session.o
OBJS+=pid.o dreg.o ddesc.o esil.o ${STATIC_OBJS}

ifeq (${OSTYPE},darwin)
ifneq (${NATIVE_OBJS},)
OBJS+= p/${NATIVE_OBJS}
endif
endif

ifeq ($(OSTYPE),$(filter $(OSTYPE),gnulinux android))
CFLAGS+=-I../bin/format/elf
OBJS+=$(addprefix p/,$(NATIVE_OBJS))
endif

ifneq (${COREDUMP_OBJS},)
ifeq ($(OSTYPE),$(filter $(OSTYPE),gnulinux))
OBJS+= p/${COREDUMP_OBJS}
endif
endif

ifneq (,$(findstring bsd,$(OSTYPE))$(findstring dragonfly,$(OSTYPE)))
ifneq (${NATIVE_OBJS},)
OBJS+=$(addprefix p/,$(NATIVE_OBJS))
endif
endif

plugins:
	$(MAKE) -C p all

ios:
	cd ../.. && sys/rebuild.sh iosdbg

include ../rules.mk

libs: ${LIBSO} ${LIBAR}

.PHONY: foo plugins tests libs ios

=== libr/flag/Makefile ===
include ../config.mk

NAME=r_flag
DEPS=r_util
OBJS=flag.o zones.o tags.o

include ../rules.mk

=== libr/hash/Makefile ===
include ../config.mk

NAME=r_hash
PCLIBS=@LIBXXHASH@
# HACK
ifneq ($(OSTYPE),darwin)
ifneq ($(OSTYPE),haiku)
LDFLAGS+=-lm
LINK=-lm
endif
endif

DEPS=r_util
OBJS=state.o hash.o hamdist.o crca.o fletcher.o
OBJS+=entropy.o calc.o adler32.o luhn.o

ifeq ($(HAVE_LIB_SSL),1)
CFLAGS+=${SSL_CFLAGS}
LDFLAGS+=${SSL_LDFLAGS}
LINK+=${SSL_LDFLAGS}
else
OBJS+=md4.o md5.o sha1.o sha2.o
endif

ifeq ($(USE_LIB_XXHASH),1)
LDFLAGS+=${LIB_XXHASH}
LINK+=${LIBXXHASH}
else
OBJS+=xxhash.o
endif

include ../rules.mk

=== libr/main/Makefile ===
include ../config.mk

NAME=r_main

OBJS=version.o
OBJS+=main.o
OBJS+=rax2.o
OBJS+=rasm2.o
OBJS+=ragg2.o
OBJS+=rarun2.o
OBJS+=rabin2.o
OBJS+=rafind2.o
OBJS+=r2agent.o
OBJS+=radiff2.o
OBJS+=radare2.o
OBJS+=rahash2.o

# See MAIN_LINK_ALL
include deps.mk

include ../rules.mk

=== shlr/gdb/Makefile ===
include ../../libr/config.mk
include ../../mk/platform.mk
include ../../mk/$(COMPILER).mk
include ../../shlr/zip/deps.mk
EDITOR?=vim
CC?=gcc
CC_AR?=ar
AR?=$(CC_AR)
RANLIB?=ranlib
LIBNAME=libgdbr
LIBFILE=$(LIBNAME).$(EXT_SO)
CFLAGS+=-I$(LIBR)/include $(PIC_CFLAGS)
CFLAGS+=-Iinclude -I${LIBR}/include
MAJOR=0
MINOR=1
LD=$(CC)
ifeq ($(LD),cccl)
LDFLAGS+=-L${LIBR}/socket -llibr_socket
LDFLAGS+=-L${LIBR}/util -llibr_util
EXT_AR?=lib
else
LDFLAGS+=-L${LIBR}/socket -lr_socket
LDFLAGS+=-L${LIBR}/util -lr_util
EXT_AR?=a
endif

ifeq (${OSTYPE},darwin)
LDFLAGS_SHARED=-dynamiclib
else
LDFLAGS_SHARED=-shared
endif

#OSTYPE=windows
include ../../libr/socket/deps.mk

# Test variables
TEST_D= $(PWD)/test
BIN=$(PWD)/bin
UNIT_TEST=$(TEST_D)/unit.c
CLIENT=$(TEST_D)/client.c

PWD=$(shell pwd)
TEST=test
LIB=lib

TEST_INCLUDES += $(INCLUDES) -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include

SRC_D=src
SRC_C=$(wildcard $(SRC_D)/*.c) $(wildcard $(SRC_D)/*/*.c)
SRC_O=$(SRC_C:.c=.o)

TEST_C=$(wildcard $(TEST_D)/*.c)
TEST_O=$(TEST_C:.c=.o)

all: $(LIB)/$(LIBNAME).${EXT_AR}
#	make

default: make

prepare:
	mkdir -p $(LIB)

$(LIB):
	mkdir -p $(LIB)

$(LIB)/$(LIBNAME).${EXT_AR}: $(LIB) $(SRC_O)
ifeq ($(WITHPIC),1)
	$(LD) $(PIC_CFLAGS) $(LDFLAGS_SHARED) -o $(LIB)/$(LIBFILE) $(CFLAGS) $(SRC_O) $(LDFLAGS) $(LINK)
endif
	$(AR) rvs $(LIB)/$(LIBNAME).${EXT_AR} $(SRC_O)
	# required for solaris and w32
	$(RANLIB) $(LIB)/$(LIBNAME).${EXT_AR}

clean:
	-rm -f $(SRC_O)
	-rm -rf lib

unit: lib
	$(CC) $(CFLAGS) $(TEST_INCLUDES) -c $(UNIT_TEST) -o $(TEST_D)/unit.o
	$(LD) $(TEST_D)/unit.o -o $(TEST_D)/unit -L$(LIB) -lgdbr -lglib-2.0

run_unit: unit
	LD_LIBRARY_PATH=./lib ./test/unit

client: lib
	$(CC) $(CFLAGS) $(INCLUDES) -c $(CLIENT) -o $(TEST_D)/client.o
	$(LD) $(TEST_D)/client.o -o $(TEST_D)/client -L$(LIB) -lgdbr

run_test: client
	rarun2 libpath=./lib program=./test/client

gdb_test: client
	rarun2 libpath=./lib system="gdb ./test/client"

valgrind_test: client
	rarun2 libpath=./lib system="valgrind --track-origins=yes -v --leak-check=full ./test/client"

edit:
	$(EDITOR) -c "args **/*.h **/*.c"

=== debian/control ===
Source: radare2
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Andrej Shadura <andrewsh@debian.org>,
           Sebastian Reichel <sre@debian.org>
Build-Depends: debhelper-compat (= 12),
               libcapstone-dev,
               libgmp-dev,
               libkvm-dev [kfreebsd-any],
               libmagic-dev,
               libuv1-dev,
               libxxhash-dev,
               libzip-dev,
               liblz4-dev,
               freebsd-glue,
               meson,
               pkg-config,
               python3,
               python3-setuptools,
               zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://www.radare.org
Vcs-Browser: https://salsa.debian.org/pkg-security-team/radare2
Vcs-Git: https://salsa.debian.org/pkg-security-team/radare2.git

Package: radare2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libradare2-dev
Description: free and advanced command line hexadecimal editor
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.

Package: libradare2-4.2.1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libradare2-common (>= ${source:Version})
Multi-Arch: same
Description: libraries from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the libraries from radare2.

Package: libradare2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libradare2-4.2.1 (= ${binary:Version}),
         libcapstone-dev, libmagic-dev, libuv1-dev, liblz4-dev,
         libzip-dev,
Description: devel files from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the devel files from radare2.

Package: libradare2-common
Multi-Arch: foreign
Architecture: all
Depends: ${misc:Depends}
Description: arch independent files from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the arch independent files from radare2.
